#include <stdint.h>
#include <stdbool.h>

sbit C_METER_RST 	at GPIOC_ODR.B2;
sbit C_METER_INT 	at GPIOD_ODR.B10;

void system_setup( void );
void setup_interrupt( void );
void InitTimer2( void );
float calibration( uint32_t count );

volatile bool flag;
volatile uint32_t start_val;
volatile uint32_t end_val;
char uart_text[ 20 ];



uint32_t int_count = 0;
uint32_t sec_count = 0;
uint32_t timer_count_end = 0;
bool sec_flag = false;
float calib = 0.0f;
float period = 0.0f;
float CO = 0.0f;
float final = 0.0f;
float t = 0.0f;

void main() 
{
    //Local Declarations
    bool calibration_flag = true;
    //char uart_text[30] = { 0 };

    system_setup();
    setup_interrupt();
    InitTimer2();
    
    t = 1.0f / 23119.0f;
    calib = t / 77616.0f;
    
    int_count = 0;

    while(1)
    {
    
        if( sec_flag )
        {
            /*sprintf( uart_text, "Interrupts : %u, Seconds: %u \r\n", timer_count_end, sec_count );
            UART1_Write_Text( uart_text );
            //sec_flag = false;

            period = 1.0f / timer_count_end;
            CO = period / 77616.0f;
            final = ( CO * calib ) / ( calib - CO );
          //  sprintf( uart_text, "Calibrated: %d, Final: %d \r\n", calib, final );
            UART1_Write_Text( "Final: " );
            FloatToStr( final, uart_text );
            UART1_Write_Text( uart_text );
            UART1_Write_Text( "\r\n" );
            sec_flag = false;
            int_count = 0;
            timer_count_end = 0;*/
        }
        
    
    }

}

float calibration( uint32_t count )
{
    float t = 0.0;
    float calibrated = 0.0;
    
    t = 1 / count;
    calibrated = t / 77616;
    
    return calibrated;
}

void system_setup( void )
{
    //GPIO
    GPIO_Digital_Output( &GPIOC_BASE, _GPIO_PINMASK_2 );    //RST
    GPIO_Digital_Input( &GPIOD_BASE, _GPIO_PINMASK_10 );    //INT

    //RST Toggle
    C_METER_RST = 0;
    Delay_ms(50);
    C_METER_RST = 1;

    //UART
    UART1_Init( 9600 );
    UART1_Write_Text( "UART Initialized\r\n" );

}

void setup_interrupt( void )
{
  GPIO_Digital_Output(&GPIOE_BASE, _GPIO_PINMASK_HIGH);  // Enable digital output on PORTD
  GPIOE_ODR = 0xAAAA;
  GPIO_Digital_Input(&GPIOD_BASE, _GPIO_PINMASK_10);

  RCC_APB2ENR.AFIOEN = 1;              // Enable clock for alternate pin functions
  AFIO_EXTICR3 = 0x0300;               // PD10 as External interrupt
  EXTI_FTSR = 0x00000400;              // Set interrupt on Rising edge
  EXTI_IMR |= 0x00000400;              // Set mask
  NVIC_IntEnable(IVT_INT_EXTI15_10);   // Enable External interrupt
  EnableInterrupts();                  // Enables the processor interrupt.
}

void ExtInt() iv IVT_INT_EXTI15_10 ics ICS_AUTO 
{
   EXTI_PR.B10 = 1;                             // clear flag
   int_count++;
}

void InitTimer2() //1 second
{
  RCC_APB1ENR.TIM2EN = 1;
  TIM2_CR1.CEN = 0;
  TIM2_PSC = 1124;
  TIM2_ARR = 63999;
  NVIC_IntEnable(IVT_INT_TIM2);
  TIM2_DIER.UIE = 1;
  TIM2_CR1.CEN = 1;
}

void Timer2_interrupt() iv IVT_INT_TIM2 
{
  TIM2_SR.UIF = 0;
  /*sec_count++;
  timer_count_end = int_count;
  int_count = 0;
  sec_flag = true;*/
  
  if( flag )
  {
     end_val = int_count;
     LongToStr( end_val - start_val, uart_text );
     UART_Write_Text( uart_text );
  
  } else {
  
     start_val = int_count;
  }
  
  flag =~ flag;
  
  
}