#line 1 "C:/Users/Corey/Documents/Projects/C_Meter/C_Meter_ARM.c"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdint.h"





typedef signed char int8_t;
typedef signed int int16_t;
typedef signed long int int32_t;
typedef signed long long int64_t;


typedef unsigned char uint8_t;
typedef unsigned int uint16_t;
typedef unsigned long int uint32_t;
typedef unsigned long long uint64_t;


typedef signed char int_least8_t;
typedef signed int int_least16_t;
typedef signed long int int_least32_t;
typedef signed long long int_least64_t;


typedef unsigned char uint_least8_t;
typedef unsigned int uint_least16_t;
typedef unsigned long int uint_least32_t;
typedef unsigned long long uint_least64_t;



typedef signed long int int_fast8_t;
typedef signed long int int_fast16_t;
typedef signed long int int_fast32_t;
typedef signed long long int_fast64_t;


typedef unsigned long int uint_fast8_t;
typedef unsigned long int uint_fast16_t;
typedef unsigned long int uint_fast32_t;
typedef unsigned long long uint_fast64_t;


typedef signed long int intptr_t;
typedef unsigned long int uintptr_t;


typedef signed long long intmax_t;
typedef unsigned long long uintmax_t;
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdbool.h"



 typedef char _Bool;
#line 4 "C:/Users/Corey/Documents/Projects/C_Meter/C_Meter_ARM.c"
sbit C_METER_RST at GPIOC_ODR.B2;
sbit C_METER_INT at GPIOD_ODR.B10;

void system_setup( void );
void setup_interrupt( void );
void InitTimer2( void );
float calibration( uint32_t count );

volatile  _Bool  flag;
volatile uint32_t start_val;
volatile uint32_t end_val;
char uart_text[ 20 ];



uint32_t int_count = 0;
uint32_t sec_count = 0;
uint32_t timer_count_end = 0;
 _Bool  sec_flag =  0 ;
float calib = 0.0f;
float period = 0.0f;
float CO = 0.0f;
float final = 0.0f;
float t = 0.0f;

void main()
{

  _Bool  calibration_flag =  1 ;


 system_setup();
 setup_interrupt();
 InitTimer2();

 t = 1.0f / 23119.0f;
 calib = t / 77616.0f;

 int_count = 0;

 while(1)
 {

 if( sec_flag )
 {
#line 64 "C:/Users/Corey/Documents/Projects/C_Meter/C_Meter_ARM.c"
 }


 }

}

float calibration( uint32_t count )
{
 float t = 0.0;
 float calibrated = 0.0;

 t = 1 / count;
 calibrated = t / 77616;

 return calibrated;
}

void system_setup( void )
{

 GPIO_Digital_Output( &GPIOC_BASE, _GPIO_PINMASK_2 );
 GPIO_Digital_Input( &GPIOD_BASE, _GPIO_PINMASK_10 );


 C_METER_RST = 0;
 Delay_ms(50);
 C_METER_RST = 1;


 UART1_Init( 9600 );
 UART1_Write_Text( "UART Initialized\r\n" );

}

void setup_interrupt( void )
{
 GPIO_Digital_Output(&GPIOE_BASE, _GPIO_PINMASK_HIGH);
 GPIOE_ODR = 0xAAAA;
 GPIO_Digital_Input(&GPIOD_BASE, _GPIO_PINMASK_10);

 RCC_APB2ENR.AFIOEN = 1;
 AFIO_EXTICR3 = 0x0300;
 EXTI_FTSR = 0x00000400;
 EXTI_IMR |= 0x00000400;
 NVIC_IntEnable(IVT_INT_EXTI15_10);
 EnableInterrupts();
}

void ExtInt() iv IVT_INT_EXTI15_10 ics ICS_AUTO
{
 EXTI_PR.B10 = 1;
 int_count++;
}

void InitTimer2()
{
 RCC_APB1ENR.TIM2EN = 1;
 TIM2_CR1.CEN = 0;
 TIM2_PSC = 1124;
 TIM2_ARR = 63999;
 NVIC_IntEnable(IVT_INT_TIM2);
 TIM2_DIER.UIE = 1;
 TIM2_CR1.CEN = 1;
}

void Timer2_interrupt() iv IVT_INT_TIM2
{
 TIM2_SR.UIF = 0;
#line 138 "C:/Users/Corey/Documents/Projects/C_Meter/C_Meter_ARM.c"
 if( flag )
 {
 end_val = int_count;
 LongToStr( end_val - start_val, uart_text );
 UART_Write_Text( uart_text );

 } else {

 start_val = int_count;
 }

 flag =~ flag;


}
